; ***************************************************
; ********* Disegno di un muro di sostegno   ********
; ********* Programma scritto da Marco Monni ********
; ********* Ver 3.0 - Gennaio 2000           ********
; *********                                  ********
; *********         FREEWARE VERSION         ********
; *********                                  ********
; ***************************************************

(defun c:wall ()

    (setq pu (getpoint "\nPunto inserimento: "))

    ; vengono richiesti i dati geometrici del muro

    (setq h  (getdist "\nAltezza 'h' del muro (cm): ") 
          a  (getdist "\nSommit 'a' (cm): ")
          p  (getdist "\nPiede 'p' (cm): ")
          b  (getdist "\nBase esterna 'b' (cm): ")
          c  (getdist "\nBase interna 'c' (cm): ")
          d  (getdist "\nSpessore soletta 'd' (cm): ")
          s2 (getdist "\nAltezza dente 's2' (cm): ")
          s1 (getdist "\nLarghezza dente 's1' (cm): ")
          in (getdist "\nInterasse ferri di ripartizione (cm): ")
          cf (getdist "\nCopriferro 'cf' (cm): ")
          sc (getdist "\nScala 'x' di stampa (1:x) ")      
    )
    
    ; viene abilitato il layer "0" come layer corrente

    (command "_-layer"
             "_set"
             0
             end
     )

    ; viene disattivato lo snap
   
    (command "_-osnap"
             "off"
    )

    ; vengono fissate le coordinate del perimetro esterno del muro    
  
    (setq     x1  (car pu)  
              y1  (car (cdr pu))         
              x2  (+ x1  a)
              y2  (car (cdr pu))
              x3  (+ x1  a)
              y3  (- y2 h)
              x4  (+ x3 c)
              y4  (- y2 h)
              x5  (+ x3 c)
              y5  (- y4 (+ d s2))
              x6  (- x5 s1)
              y6  (- y4 (+ d s2))
              x7  (- x5 s1)
              y7  (+ y6 s2)
              x8  (- x2 (+ b p))
              y8  (+ y6 s2)
              x9  (- x2 (+ b p))
              y9  (+ y8 d)
              x10 (- x3 p)
              y10 (+ y8 d) 
      )

    ; vengono definite le coordinate del punto 11

    (setq     m1  (- y7 y1)
              m2  (- x10 x1)
              m3  (- y10 y1)
              m4  (/ m2 m3)
              x11 (+ (* m1 m4) x1)
              y11 (+ y6 s2)
    )
    
    ; a ciascuna coppia di coordinate viene associato un punto
    
    (setq p1 (list x1 y1)
          p2 (list x2 y2)
          p3 (list x3 y3)
          p4 (list x4 y4)
          p5 (list x5 y5)
          p6 (list x6 y6)
          p7 (list x7 y7)
          p8 (list x8 y8)
          p9 (list x9 y9)
          p10 (list x10 y10)
          p11 (list x11 y11)

    )

    ; vengono uniti i punti del perimetro esterno tramite una polilinea

    (command "_pline" 
              p1 
              p2 
              p3 
              p4
              p5 
              p6
              p7
              p8
              p9
              p10
              "_c"
    )

    ; vengono create le coordinate dei punti per il perimetro del magrone

    (setq    xm1 (- x8 8)
             ym2 (- y8 8) 
             xm3 (- x7 8)
             ym4 (- y6 8)
             xm5 (+ x5 8)
    )

    ; vengono creati i punti per il perimetro del magrone

    (setq    m1 (list xm1 y8)
             m2 (list xm1 ym2)
             m3 (list xm3 ym2)
             mm4(list xm3 ym4)
             m5 (list xm5 ym4)
             m6 (list xm5 y5)
             m7 (list x5 y5)
    )

    ; vengono uniti i punti del magrone tramite una polilinea

    (command "_pline" 
             p8
             m1
             m2
             m3
             mm4
             m5
             m6
             m7
             ""
     )        

    ; viene creato il layer "1", di colore blu, in cui verranno disegnati i ferri d'armatura

    (command "_-layer"
             "_make"
             1
             "_color"
             5
             1
             end
     )

     ; vengono fissate le coordinate dei ferri d'armatura interni al muro

     (setq    xa1  (+ x1 cf)
              ya1  (- y1 cf)
              xa2  (- x2 cf)
              ya2  (- y1 cf)
              xa3  (- x3 cf)
              ya3  (+ y7 cf)
              xa4  (+ x11 cf)
              ya4  (+ y7 cf)
              xa5  (+ x9 cf)
              ya5  (+ y7 cf)
              xa6  (+ x9 cf)
              ya6  (- y9 cf)
              xa7  (- x5 cf)
              ya7  (- y9 cf)
              xa8  (- x5 cf)
              ya8  (+ y7 cf)
              xa9  (- x5 cf)
              ya9  (+ y5 cf)
              xa10 (+ x6 cf)
              ya10 (+ y5 cf)
              xa11 (+ x6 cf)
              ya11 (- y9 cf)
    )

    ; a ciascuna coppia di coordinate viene associato un punto

    (setq    a1  (list xa1 ya1)
             a2  (list xa2 ya2)
             a3  (list xa3 ya3)
             a4  (list xa4 ya4)
             a5  (list xa5 ya5)
             a6  (list xa6 ya6)
             a7  (list xa7 ya7)
             a8  (list xa8 ya8)
             a9  (list xa9 ya9)
             a10 (list xa10 ya10)
             a11 (list xa11 ya11)
    )

   ; vengono uniti i punti dei ferri d'armatura interni

    (command "__pline" a1 a2 a3 a4 "_c")
    (command "__pline" a6 a7 a8 a5 "_c")
    (if (> s2 0) (command "_pline" a7 a9 a10 a11 _"c"))

   ; vengono fissate le coordinate dei ferri d'armatura interni al muro

     (setq    xb1  (+ xa8 50)
              yb1  (+ y7 cf)
              xb2  (+ xb1 (- xa1 xa4))
              yb2  (- y1 cf)
              xb3  (+ xb2 (- xa2 xa1))
              yb3  (- y1 cf)


              xb5  (+ xb1 40)
              yb5  (+ y7 cf)
              xb6  (+ xb5 (- xa3 xa4))
              yb6  (+ y7 cf)
              xb7  (+ xb5 (- xa3 xa4))
              yb7  (+ ya4 (* 3 d))
              m5   (- yb7 y1)
              xm6  (+ (* m5 m4) x1)
              xb4 (+ xb5 (- xm6 x10))
              yb4  (+ ya4 (* 3 d))

              xb8  (+ xb6 40)
              yb8  (+ y7 cf)
              xb9  (+ xb6 40)
              yb9  (- y1 cf)
              xb10 (- xb9 (- xa2 xa1))
              yb10 (- y1 cf)

              xb11 (+ x9 cf)
              yb11 (- (- ya9 70) (- ya6 ya5))
              xb12 (+ x9 cf)
              yb12 (- ya9 70)
              xb13 (- x5 cf)
              yb13 (- ya9 70)
              xb14 (- x5 cf)
              yb14 (- yb12 (- ya6 ya5))

              xb15 (+ x9 cf)
              yb15 (- yb11 20)
              xb16 (+ x9 cf)
              yb16 (- yb15 (- ya6 ya5))
              xb17 (- x5 cf)
              yb17 (- yb15 (- ya6 ya5))
              xb18 (- x5 cf)
              yb18 (- yb11 20)

              xb19 (+ x6 cf)
              yb19 (+ ya11 50)
              xb20 (+ xb19 (- xa7 xa11))
              yb20 (+ yb19 (- ya7 ya9))
              xb21 (- xb20 2)
              yb21 (+ yb19 (- ya7 ya9))
              xb22 (- xb20 2)
              yb22 (- yb21 10)

              xb23 (+ x1 cf)
              yb23 (- ya1 1.0)
              xb24 (+ xb23 (* 2 1.0))
              yb24 (- ya1 1.0)
              yb25 (- ya1 (+ 1 in))
              yb27 (- ya1 (+ 1 (* 2 in)))
              xb29 (- xa2 2)
              xb35 (+ xa5 1)
              yb36 (+ ya5 (* 2 1.0))
              xb37 (+ xa5 (+ 1 in))
              xb39 (+ xa5 (+ 1 (* 2 in)))
              yb41 (- ya6 (* 2 1.0)) 
      )

    ; a ciascuna coppia di coordinate viene associato un punto
    
    (setq    b1  (list xb1 yb1)
             b2  (list xb2 yb2)
             b3  (list xb3 yb3)
             b4  (list xb4 yb4)
             b5  (list xb5 yb5)
             b6  (list xb6 yb6)
             b7  (list xb7 yb7)
             b8  (list xb8 yb8)
             b9  (list xb9 yb9)
             b10 (list xb10 yb10)
             b11 (list xb11 yb11)
             b12 (list xb12 yb12)
             b13 (list xb13 yb13)
             b14 (list xb14 yb14)
             b15 (list xb15 yb15)
             b16 (list xb16 yb16)
             b17 (list xb17 yb17)
             b18 (list xb18 yb18)
             b19 (list xb19 yb19)
             b20 (list xb20 yb20)
             b21 (list xb21 yb21)
             b22 (list xb22 yb22)
             b23 (list xb23 yb23)
             b24 (list xb24 yb24)
             b25 (list xb23 yb25)
             b26 (list xb24 yb25)
             b27 (list xb23 yb27)
             b28 (list xb24 yb27)
             b29 (list xb29 yb23)
             b30 (list xa2  yb23)
             b31 (list xb29 yb25)
             b32 (list xa2  yb25)
             b33 (list xb29 yb27)
             b34 (list xa2  yb27)
             b35 (list xb35 ya5 )
             b36 (list xb35 yb36)
             b37 (list xb37 ya5 )
             b38 (list xb37 yb36)
             b39 (list xb39 ya5 )
             b40 (list xb39 yb36)
             b41 (list xb35 yb41)
             b42 (list xb35 ya6 )
             b43 (list xb37 yb41)
             b44 (list xb37 ya6 )
             b45 (list xb39 yb41)
             b46 (list xb39 ya6 )

    )

  ; vengono disegnati i ferri d'armatura sfilati

    (command "_pline" b1 b2 b3 "")
    (command "_pline" b4 b5 b6 b7 "")
    (command "_pline" b8 b9 b10 "")
    (command "_pline" b11 b12 b13 b14 "")
    (command "_pline" b15 b16 b17 b18 "")
    (if (> s2 0) (command "_rectang" b19 b20)); se s2  maggiore di zero disegna la staffa del dente
    (if (> s2 0) (command "_line" b21 b22 "")); se s2  maggiore di zero disegna la staffa del dente
    (command "_circle" "2p" b23 b24)
    (command "_circle" "2p" b29 b30)
    (command "_circle" "2p" b31 b32)
    (command "_circle" "2p" b33 b34)
    (command "_circle" "2p" b35 b36)
    (command "_circle" "2p" b37 b38)
    (command "_circle" "2p" b39 b40)
    (command "_circle" "2p" b41 b42)
    (command "_circle" "2p" b43 b44)
    (command "_circle" "2p" b45 b46)

  ; viene creato il layer "2", di colore ciano, in cui verranno poste le quote

    (command "_-layer"
             "_make"
             2
             "_color"
             4
             2
             _end
     )

  ; quotatura del muro

    (command "_dim"
             "_dimtxt" 0.18 ""
             "_dimasz" 0.18 ""
             "_dimgap" 0.07 ""
             "_dimexe" 0.18 ""
             "_dimexo" 0.60 ""
             "_dimtofl" 1 "1"
             "_dimdec" 1 ""
             "_dimtih" 0 ""
             "_dimtoh" 0 ""
             "_dimscale" sc ""
             "_hor" p1 p2  (list x1 (+ 20 y1))  ""
             "_hor" p3 p4  (list x3 (+ 20 y3))  ""
             "_hor" (list x10 y6) (list x3 y6) (list x7 (- y6 20))  ""
             "_hor" (list x9 y6) (list x10 y6) (list x7 (- y6 20))  ""
             "_hor" (list x8 y6) (list x5 y6)  (list x7 (- y6 35)) ""
             "_ver" p8 p9  (list (- x9 40) y9)  ""
             "_ver" (list x8 y1) p9  (list (- x9 40) y9)  ""
             "_leader" (list (- xa4 10) ya6) (list (- xa4 20) (+ ya6 50)) (list (- xa4 25) (+ ya6 50))"" "Pos. 1-2"
             "_leader" (list (- xa4 25) ya5) (list (- xa4 20) (+ ya6 50)) (list (- xa4 25) (+ ya6 50))"" "Pos. 1-2"
             "_leader" (list xa4 (+ ya4 (/ (- ya6 ya5) 2))) (list (- xa4 10) (- ya4 31)) (list (- xa4 15) (- ya4 31))"" "Pos. 3"
             "_leader" (list (+ xm6 cf) yb4) (list (- xm6 10) (+ 15 (- ya1 (/ (- ya1 ya6) 2)))) (list (- xm6 15) (+ 15 (- ya1 (/ (- ya1 ya6) 2))))"" "Pos. 4"  
             "_leader" (list xa3 (- ya1 (/ (- ya1 ya6) 2))) (list (+ xa3 10) (+ 40 (- ya1 (/ (- ya1 ya6) 2)))) (list (+ xa3 15) (+ 40 (- ya1 (/ (- ya1 ya6) 2))))"" "Pos. 5"
             "_leader" b23 (list (- xa1 20) (+ yb25 30)) (list (- xa1 25) (+ yb25 30)) "" "Ripartitori 1%%C8/"
             "_leader" b29 (list (- xa1 20) (+ yb25 30)) (list (- xa1 25) (+ yb25 30)) "" "Ripartitori 1%%C8/" 
             "_exit"
             "_text" "_j" "_c" (list (- xa1 23) (+ yb25 33)) (* 0.18 sc) 0 (fix in) ""
    )

  ; quotatura del "dente"

  (if (> s2 0) (command "_dim" "_hor" p6 p5  (list x7 (- y6 20))  "" "_exit"))
  (if (> s2 0) (command "_dim" "_hor" (list x3 y6) (list x7 y6) (list x7 (- y6 20)) "" "_exit"))
  (if (> s2 0) (command "_dim" "_ver" p4 p5  (list (+ x5 20) y5)  "" "_exit"))
  (if (> s2 0) (command "_dim" "_ver" p8 (list x8 y6) (list (- x9 40) y8)  "" "_exit"))

  ; vengono contrassegnate le posizioni dei ferri

  (setq di (+ 3 (* 0.18 sc))); distanza della scritta dal bordo del ferro

  ; ferri della posizione n. 1
  (command "_text" "_j" "_c" (list (+ xb12 (/ (- xb13 xb12) 2)) (+ yb12 3)) (* 0.18 sc) 0 "Pos.1 - 1%%C12/20 LT=")
  (command "_text" "_j" "_c" (list (+ xb12 (/ (- xb13 xb12) 2) (* (* 0.18 sc) 11)) (+ yb12 3)) (* 0.18 sc) 0 (fix(+ (distance b11 b12) (distance b12 b13) (distance b13 b14)))); scrive la lunghezza totale del ferro in pos. 1
  (command "_text" "_j" "_c" (list (+ xb12 (/ (- xb13 xb12) 2)) (- yb12 di)) (* 0.18 sc) 0 (fix(distance b12 b13)))
  (command "_text" "_j" "_c" (list (+ xb12 di) (+ yb11 (/ (distance b11 b12) 2))) (* 0.18 sc) 90 (fix(distance b11 b12)))
  (command "_text" "_j" "_c" (list (- xb14 2) (+ yb11 (/ (distance b11 b12) 2))) (* 0.18 sc) 90 (fix(distance b13 b14)))   

  ; ferri della posizione n. 2
  (command "_text" "_j" "_c" (list (+ xb12 (/ (- xb13 xb12) 2)) (- yb16 di)) (* 0.18 sc) 0 "Pos.2 - 1%%C12/20 LT=")
  (command "_text" "_j" "_c" (list (+ xb12 (/ (- xb13 xb12) 2)(* (* 0.18 sc) 11)) (- yb16 di)) (* 0.18 sc) 0 (fix(+ (distance b15 b16) (distance b16 b17) (distance b17 b18)))); scrive la lunghezza totale del ferro in pos. 2
  (command "_text" "_j" "_c" (list (+ xb12 (/ (- xb13 xb12) 2)) (+ yb16 3)) (* 0.18 sc) 0 (fix(distance b12 b13)))
  (command "_text" "_j" "_c" (list (+ xb12 di) (+ yb16 (/ (distance b16 b15) 2))) (* 0.18 sc) 90 (fix(distance b16 b15)))
  (command "_text" "_j" "_c" (list (- xb14 2) (+ yb16 (/ (distance b16 b15) 2))) (* 0.18 sc) 90 (fix(distance b16 b15)))

  ; ferri della posizione n. 3
  (command "_text" "_j" "_c" (list (+ xb5 (/ (distance b5 b6) 2)) (- yb5 (* di 2.5))) (* 0.18 sc) 0 "Pos.3 - 1%%C12/20 LT=")
  (command "_text" "_j" "_c" (list (+ xb5 (/ (distance b5 b6) 2) (* (* 0.18 sc) 11)) (- yb5 (* di 2.5))) (* 0.18 sc) 0 (fix(+ (distance b4 b5) (distance b5 b6) (distance b6 b7)))); scrive la lunghezza totale del ferro in pos. 3
  (command "_text" "_j" "_c" (list (+ xb5 (/ (distance b5 b6) 2)) (- yb5 di)) (* 0.18 sc) 0 (fix(distance b5 b6)))      
  (command "_text" "_j" "_c" (list (- xb5 2) (+ yb5 (/ (distance b5 b4) 2))) (* 0.18 sc) 90 (fix(distance b5 b4)))
  (command "_text" "_j" "_c" (list (+ xb6 di) (+ yb6 (/ (distance b6 b7) 2))) (* 0.18 sc) 90 (fix(distance b6 b7)))

  ; ferri posizione n. 4
  (setq l1 (+ yb1 (/ (- yb2 yb1) 2))
        l2 (- l1 yb2)
        l3 (- yb1 yb2)
        l4 (- xb1 xb2)
        xl (+ (* (/ l2 l3) l4) xb2)

        n1 (+ yb1 (/ (distance b1 b2) 2) (* (* 0.18 sc) 11))
        n2 (- n1 yb2)
        xn (+ (* (/ n2 l3) l4) xb2) 
  )

  (command "_text" "_j" "_c" (list (- xl 3) l1) (* 0.18 sc) (list (- xb2 3) yb2) "Pos.4 - 1%%C12/20 LT=")
  (command "_text" "_j" "_c" (list (- xn 3) n1) (* 0.18 sc) (list (- xb2 3) yb2) (fix(+ (distance b1 b2) (distance b2 b3)))); scrive la lunghezza totale del ferro in pos. 4
  (command "_text" "_j" "_c" (list (+ xl di) l1) (* 0.18 sc) (list (- xb2 3) yb2) (fix(distance b1 b2)))
  (command "_text" "_j" "_c" (list (+ xb2 (/ (distance b2 b3) 2)) (- yb2 di)) (* 0.18 sc) 0 (fix(distance b2 b3)))

  ; ferri posizione n. 5
  (command "_text" "_j" "_c" (list (+ xb8 di) (+ yb1 (/ (distance b1 b2) 2))) (* 0.18 sc) 90 "Pos.5 - 1%%C12/20 LT=" "")
  (command "_text" "_j" "_c" (list (+ xb8 di) (+ yb1 (/ (distance b1 b2) 2) (* (* 0.18 sc) 11))) (* 0.18 sc) 90 (fix(+ (distance b1 b2) (distance b2 b3))) ""); scrive la lunghezza totale del ferro in pos. 5
  (command "_text" "_j" "_c" (list (- xb8 3) (+ yb1 (/ (distance b1 b2) 2))) (* 0.18 sc) 90 (fix(distance b1 b2)) "")
  (command "_text" "_j" "_c" (list (+ xb10 (/ (distance b10 b9) 2)) (- yb2 di)) (* 0.18 sc) 0 (fix(distance b10 b9)) "")

  ; ferri posizione n. 6; vengono stampati solo se s2  maggiore di zero (cio se c' il "dente")
  (if (> s2 0)
  (command "_text" (list (+ xb20 (* di 2.0)) yb19) (* 0.18 sc) 90 "Pos.6 - 1%%C12/20 LT=")
  ) 
  (if (> s2 0)
  (command "_text" (list (+ xb20 (* di 2.0)) (+ yb19 (* (* 0.18 sc) 18))) (* 0.18 sc) 90 (fix(+ (distance a10 a9) (distance a9 a7) (distance a7 a11) (distance a11 a10) (distance b21 b22)))); scrive la lunghezza totale del ferro in pos. 5
  )
  (if (> s2 0)
  (command "_text" "_j" "_c" (list (+ xb19 (/ (distance a10 a9) 2)) (- yb19 di)) (* 0.18 sc) 0 (fix(distance a10 a9)))
  )
  (if (> s2 0)
  (command "_text" "_j" "_c" (list (+ xb19 (/ (distance a10 a9) 2)) (+ yb20 3)) (* 0.18 sc) 0 (fix(distance a10 a9)))
  )
  (if (> s2 0)
  (command "_text" "_j" "_c" (list (- xb19 3) (+ yb19 (/ (distance a10 a11) 2))) (* 0.18 sc) 90 (fix(distance a10 a11)))  
  )
  (if (> s2 0)
  (command "_text" "_j" "_c" (list (+ xa9 di) (+ yb19 (/ (distance a10 a11) 2))) (* 0.18 sc) 90 (fix(distance a10 a11)))
  )
  (if (> s2 0)
  (command "_text" "_j" "_c" (list (- xb22 3) (+ yb22 (/ (distance b22 b21) 2))) (* 0.18 sc) 90 (fix(distance b22 b21)))
  )

  ; stampa dati generali: copriferro, tipo di cls e acciaio, volume cls, scala del disegno
  (command "_text" (list xb1 yb13) (* 0.18 sc) 0 "Copriferro (cm)= ")
  (command "_text" (list (+ xb1 (* (* 0.18 sc) 15)) yb13) (* 0.18 sc) 0 (fix cf))
  (command "_text" (list xb1 (- yb13 (* 2 di))) (* 0.18 sc) 0 "Calcestruzzo Rck 25 kN/mmq")
  (command "_text" (list xb1 (- yb13 (* 4 di))) (* 0.18 sc) 0 "Volume cls (mc/ml)= ")

  ; vengono definite delle variabili per il calcolo dell'area del muro

  (setq area5 (* (distance p2 p3) (distance p3 p4))
        area4 (* (distance p6 p5) (distance p6 p7))
        area3 (* (distance p8 p9) (distance p9 p4))
        area2 (* (distance p1 p2) (distance p2 p3))
        area1 (- (* (distance p1 p10) 0.5 (+ (distance p1 p2) (distance p10 p3))) area2)
        areat (+ area1 area2 area3 area4)  
  )

  (command "_text" (list (+ xb1 (* (* 0.18 sc) 18)) (- yb13 (* 4 di))) (* 0.18 sc) 0 (rtos (* areat 0.0001) 2 2))

  ; N.B.: la funzione "rtos" consente di eliminare gli zeri dopo i decimali   

  (command "_text" (list xb1 (- yb13 (* 6 di))) (* 0.18 sc) 0 "Acciaio FeB 44k")
  (command "_text" (list xb1 (- yb13 (* 9 di))) (* 0.18 sc) 0 "Scala 1:")
  (command "_text" (list (+ xb1 (* (* 0.18 sc) 7)) (- yb13 (* 9 di))) (* 0.18 sc) 0 (fix sc))

  ; viene riattivato lo snap

  (command "_-osnap"
           "End,Cen,Node,Int"
  )

  ; esegue uno zoom su tutta l'estensione del disegno

   (command "_zoom" "_extents")

   (princ)
)

